<?php
/**
 * @package Deltaga
 * @version 1.2
 */
/*
Plugin Name: Deltaga.nu
Plugin URI: http://deltaga.nu/support/wordpress/
Description: This plugin makes it easy for you to integrate your event from Deltaga.nu on your Wordpress blog.
Author: Jimmy Dahl
Version: 1.2
Author URI: http://deltaga.nu/
*/

add_shortcode('deltaga-startlista', 'deltaga_startlist');
add_shortcode('deltaga-anmalan','deltaga_registration');
add_action('wp_enqueue_scripts', 'deltaga_register_scripts');

function deltaga_startlist($atts) {
	$atts = shortcode_atts(array('startlist_id' => 0, 'use_css' => true), $atts, 'deltaga_startlist');
	return '<div id="deltaga_startlista"></div>
					<script type="text/javascript">
					  var deltaga_startlista = '.$atts['startlist_id'].';
					  var deltaga_css = '.$atts['use_css'].';
					</script>';
}

function deltaga_registration($atts) {
	$atts = shortcode_atts(array('event_id' => 0), $atts, 'deltaga_registration');
	$url = 'http://deltaga.nu/tavlingar/anmalan/'.$atts['event_id'].'/iframe';
	return '<iframe onload="scroll(0,0)" id="deltaga_register" style="width: 100%;overflow: hidden;" scrolling="no" frameborder="0" src="'.$url.'"></iframe>';
}

function deltaga_register_scripts() {
	wp_register_script('deltaga-postmessage', plugins_url('js/postmessage.js', __FILE__), 'jquery', false, true);
	wp_register_script('deltaga-register', plugins_url('js/deltaga.js', __FILE__), array('jquery','deltaga-postmessage'), false, true);
	wp_enqueue_script('deltaga-register');
}


if (is_admin()) {
	add_action('admin_menu', 'deltaga_admin_menu');
	add_action('admin_enqueue_scripts', 'deltaga_admin_scripts');

	function deltaga_admin_menu() {
		add_menu_page('Deltaga.nu','Deltaga.nu','edit_pages','deltaga','deltaga_admin','');
	}

	function deltaga_admin_scripts() {
		wp_register_script('deltaga-admin', plugins_url('js/deltaga_admin.js', __FILE__), 'jquery', false, true);
		wp_enqueue_script('deltaga-admin');
	}

	function deltaga_admin() {
		echo '<div class="wrap">
						<div id="icon-edit" class="icon32"></div>
						<h2>Deltaga.nu</h2>
						<div id="deltaga-content">';
		if (isset($_POST['deltaga_action']) and $_POST['deltaga_action'] == 'login') {
	    $curl_handle = curl_init();
	    curl_setopt($curl_handle, CURLOPT_URL, 'http://deltaga.nu/api/competitions/format/json');
	    curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER, 1);
	    curl_setopt($curl_handle, CURLOPT_USERPWD, $_POST['deltaga_admin_email'] . ':' . $_POST['deltaga_admin_password']);
	    $buffer = curl_exec($curl_handle);
	    curl_close($curl_handle);
	    $result = json_decode($buffer);
	    if ($result->status != 200 and $result->error == 'Not authorized') {
		    deltaga_show_message('error','Du angav fel inloggningsuppgifter, var god försök igen!');
		    deltaga_show_login_form();
	    } elseif ($result->status == 200) {
		    echo '<h3>Dina kommande arrangemang</h3>';
		    if (count($result->data) > 0) {
			    add_thickbox();
			    echo '<table class="widefat" cellspacing="0">
			    				<thead><tr><th>Datum</th><th>Namn</th><th>Anmälan öppnar</th><th>Anmälningsformulär</th><th>Startlista</th></tr></thead>
			    				<tbody>';
			    foreach ($result->data as $comp) {
				    echo 	 '<tr>
				    					<td>'.$comp->date.'</td>
				    					<td>'.$comp->name.'</td>
				    					<td>'.$comp->open_for_entry.'</td>
				    					<td><a href="#TB_inline?width=600&height=550&inlineId=deltaga_register" class="thickbox button-secondary">Visa</a></td>
				    					<td><a href="#TB_inline?width=600&height=550&inlineId=deltaga_startlist" class="thickbox button-secondary">Visa</a></td>
				    				</tr>';
			    }
			    echo '</tbody></table>
			    			<div id="deltaga_register" style="display:none;">
			    				<h3>Bädda in anmälningsformulär</h3>
									<p>Kopiera koden nedan och klistra in den på den sida eller i det inlägg där du vill visa anmälningsformuläret.</p>
									<p><code>[deltaga-anmalan event_id="'.$comp->id.'"]</code></p>
									<p>Koden ovan kommer då att visa anmälningsformuläret för '.$comp->name.' den '.$comp->date.' inbäddat på din hemsida med hjälp av en iframe. Om kortbetalning används kommer betalfönstret att öppnas utanför din hemsida, för att tydligare visa besökaren att kommunikationen är säkrad via SSL.</p>
								</div>
								<div id="deltaga_startlist" style="display:none;">
									<h3>Bädda in startlista</h3>
									<p>Kopiera koden för den startlista du vill bädda in på hemsidan och klistra sen in koden på den sida eller i det inlägg där du vill visa den.</p>';
					if (count($comp->start_lists) > 0) {
						echo '<p><input type="checkbox" id="deltaga_use_css" checked="checked"> Använd Deltaga.nu:s css (utseende)
									<table class="widefat" cellspacing="0" id="deltaga_startlist_table">
					    			<thead><tr><th>Startlista</th><th>Kortkod att kopiera</th></tr></thead>
										<tbody>';
						foreach ($comp->start_lists as $list) {
							echo '<tr><td>'.$list->name.'</td><td><code data-id="'.$list->id.'">[deltaga-startlista startlist_id="'.$list->id.'" use_css="true"]</code></td></tr>';
						}
						echo	 '</tbody>
									</table>';
					} else {
						echo '<p><strong>Det finns inga startlistor publicerade, logga in på Deltaga.nu och publicera en startlista med den information du vill ska visas.</strong></p>';
					}
					echo '</div>';
		    } else {
			    echo '<p>Du har inga kommande arrangemang på Deltaga.nu';
		    }
	    } else {
		    deltaga_show_message('error','Något gick fel, försök gärna igen!');
		    deltaga_show_login_form();
	    }
		} else {
			deltaga_show_login_form();
		}
	}

	function deltaga_show_login_form() {
		echo	 '<p>Ange dina inloggningsuppgifter nedan för att få en lista över dina arrangemang. Därefter kommer du att få instruktioner för hur du integrerar startlista och/eller anmälningsformulär för ditt arrangemang på din hemsida eller blogg.</p>
						<form id="deltaga_login" method="post">
							<input type="hidden" name="deltaga_action" value="login">
							<input type="text" name="deltaga_admin_email" placeholder="Din e-postadress">
							<input type="password" name="deltaga_admin_password" placeholder="Ditt lösenord">
							<input type="submit" value="Logga in">
						</form>';
	}

	function deltaga_show_message($type, $message) {
		if ($type == 'error')
			echo '<div id="message" class="error"><p><strong>'.$message.'</strong></p></div>';
		elseif ($type == 'success')
			echo '<div id="message" class="updated"><p><strong>'.$message.'</strong></p></div>';
	}
}

?>
